## apper 0.9.1

=== CMakeLists.txt ===
project(Apper)
cmake_minimum_required(VERSION 2.8)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/)

find_package(KDE4 REQUIRED)
find_package(KDE4Internal REQUIRED)
find_package(KDE4Workspace REQUIRED)
include (MacroLibrary)

# Only for Debian based systems
option(DEBCONF_SUPPORT "Build Apper with debconf support" OFF)

# Yum does not support this
option(AUTOREMOVE "Build Apper with auto remove enabled" OFF)
set(HAVE_AUTOREMOVE ${AUTOREMOVE})
message(STATUS "Building Apper with auto remove: " ${AUTOREMOVE})

# AppStream application management support
option(APPSTREAM "Build Apper with AppStream support" OFF)
set(HAVE_APPSTREAM ${APPSTREAM})
message(STATUS "Building Apper with AppStream support: " ${APPSTREAM})

# Enable support for Listaller cross-distro application installer
option(LISTALLER "Build Apper with app install" OFF)
set(HAVE_LISTALLER ${LISTALLER})
message(STATUS "Building Apper with Listaller modules: " ${LISTALLER})

if (DEBCONF_SUPPORT)
    # Tries to find the package, when it finds it HAVE_DEBCONFKDE is set in config.h
    find_package(DebconfKDE REQUIRED)
    macro_bool_to_01(DebconfKDE_FOUND HAVE_DEBCONFKDE)
    macro_log_feature(DebconfKDE_FOUND "DebconfKDE" "The KDE frontend for debconf" "http://websvn.kde.org" FALSE "" "Library used for showing debconf questions.")
    message(STATUS "Building with Debconf support")
endif (DEBCONF_SUPPORT)

set(APP_VERSION 0.9.1)

# command to edit the packages origins
set(EDIT_ORIGNS_DESKTOP_NAME "" CACHE STRING "Edit origins desktop name")
if (EDIT_ORIGNS_DESKTOP_NAME)
    message(STATUS "Edit origins desktop name: " ${EDIT_ORIGNS_DESKTOP_NAME})
endif (EDIT_ORIGNS_DESKTOP_NAME)

# Generate config.h
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)

include(FindPkgConfig)

find_package(PackageKitQt4 0.9.0 REQUIRED)
include(KDE4Defaults)

add_definitions(${QT_DEFINITIONS}
    ${KDE_DEFINITIONS})

add_definitions("-std=gnu++11")

include_directories(${CMAKE_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${KDE4_INCLUDES}
    ${PackageKitQt4_INCLUDE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/libapper)

message(STATUS "PackageKit include dir: " ${PackageKitQt4_INCLUDE_DIR})

add_subdirectory(libapper)
add_subdirectory(ApperKCM)
add_subdirectory(Apper)
add_subdirectory(PkSession)
add_subdirectory(apperd)
add_subdirectory(declarative-plugins)
add_subdirectory(plasmoid)
add_subdirectory(doc)
if(LISTALLER)
    add_subdirectory(AppSetup)
endif()

include(MacroOptionalAddSubdirectory)
macro_optional_add_subdirectory( po )

=== AppSetup/CMakeLists.txt ===
pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.36)
pkg_check_modules(LISTALLER REQUIRED listaller-glib>=0.5.8)
pkg_check_modules(APPSTREAM REQUIRED appstream>=0.6.2)
pkg_check_modules(GEE REQUIRED gee-1.0>=0.6)

include_directories(${CMAKE_CURRENT_BINARY_DIR}
		    ${GLIB2_INCLUDE_DIR}
		    ${GEE_INCLUDE_DIRS}
		    ${LISTALLER_INCLUDE_DIRS}
		    ${APPSTREAM_INCLUDE_DIRS}
)

set(AppSetup_SRCS main.cpp
	SetupWizard.cpp
	SimplePage.cpp
	LicensePage.cpp
)

kde4_add_ui_files(AppSetup_SRCS
	SetupWizard.ui
	SimplePage.ui
	LicensePage.ui
)

kde4_add_executable(apper-appsetup ${AppSetup_SRCS})

set_target_properties(apper-appsetup PROPERTIES INSTALL_RPATH ${LIB_INSTALL_DIR}/apper)

target_link_libraries(apper-appsetup
		      ${KDE4_KDEUI_LIBS}
		      ${GLIB2_LIBRARIES}
		      ${LISTALLER_LIBRARIES}
		      ${APPSTREAM_LIBRARIES}
		      apper
)

install(TARGETS apper-appsetup RUNTIME DESTINATION ${BIN_INSTALL_DIR})
install(FILES apper_appsetup.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})

=== Apper/CMakeLists.txt ===
set(apper_SRCS
    MainUi.cpp
    BackendDetails.cpp
    Apper.cpp
    main.cpp
)

kde4_add_ui_files(apper_SRCS
    BackendDetails.ui
)

kde4_add_executable(apper_executable
    ${apper_SRCS}
)

target_link_libraries(apper_executable
    ${KDE4_KDEUI_LIBS}
    ${KDE4_KUTILS_LIBS}
    ${PackageKitQt4_LIBRARIES}
    apper
)

set_target_properties(apper_executable PROPERTIES INSTALL_RPATH ${LIB_INSTALL_DIR}/apper)

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/apper_executable DESTINATION ${BIN_INSTALL_DIR} RENAME apper)
install(FILES apper.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES apper_installer.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES apper_settings.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES apper_updates.desktop DESTINATION ${XDG_APPS_INSTALL_DIR})
install(FILES apper.appdata.xml DESTINATION share/appdata)

add_subdirectory(Icons)
add_subdirectory(Animations)

=== ApperKCM/CMakeLists.txt ===
set(kcm_apper_SRCS
    Settings/Settings.cpp
    Settings/OriginModel.cpp
    Updater/UpdateDetails.cpp
    Updater/DistroUpgrade.cpp
    Updater/CheckableHeader.cpp
    Updater/Updater.cpp
    FiltersMenu.cpp
    ClickableLabel.cpp
    ScreenShotViewer.cpp
    PackageDetails.cpp
    GraphicsOpacityDropShadowEffect.cpp
    CategoryModel.cpp
    BrowseView.cpp
    TransactionModel.cpp
    TransactionFilterModel.cpp
    TransactionHistory.cpp
    ApperKCM.cpp
)

kde4_add_ui_files(kcm_apper_SRCS
    Settings/Settings.ui
    Updater/UpdateDetails.ui
    Updater/Updater.ui
    PackageDetails.ui
    BrowseView.ui
    TransactionHistory.ui
    ApperKCM.ui
)

kde4_add_plugin(kcm_apper ${kcm_apper_SRCS})
target_link_libraries(kcm_apper
    ${KDE4_KDEUI_LIBS}
    ${KDE4_KIO_LIBS}
    ${KDE4_KUTILS_LIBS}
    ${PackageKitQt4_LIBRARIES}
    ${KDE4_SOLID_LIBS}
    apper
)

set_target_properties(kcm_apper PROPERTIES INSTALL_RPATH ${LIB_INSTALL_DIR}/apper)

install(TARGETS kcm_apper DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES kcm_apper.desktop DESTINATION ${SERVICES_INSTALL_DIR})

=== PkSession/CMakeLists.txt ===
set(pksession_SRCS
    AbstractIsRunning.cpp
    FilesModel.cpp
    IntroDialog.cpp
    ReviewChanges.cpp
    SessionTask.cpp
    PkInterface.cpp
    PkInstallPackageNames.cpp
    PkSearchFile.cpp
    PkIsInstalled.cpp
    PkInstallMimeTypes.cpp
    PkInstallGStreamerResources.cpp
    PkInstallFontconfigResources.cpp
    PkInstallPlasmaResources.cpp
    PkInstallPackageFiles.cpp
    PkInstallProvideFiles.cpp
    PkInstallCatalogs.cpp
    PkRemovePackageByFiles.cpp
    PkInstallPrinterDrivers.cpp
    PkSession.cpp
    main.cpp
)

qt4_add_dbus_adaptor(pksession_SRCS
    org.freedesktop.PackageKit.xml
    PkInterface.h
    PkInterface
)

kde4_add_ui_files(pksession_SRCS
    IntroDialog.ui
    ReviewChanges.ui
    SessionTask.ui
)

kde4_add_executable(apper-pk-session
    ${pksession_SRCS}
)

target_link_libraries(apper-pk-session
    ${KDE4_KDEUI_LIBS}
    ${KDE4_KIO_LIBS}
    ${PackageKitQt4_LIBRARIES}
    ${QT_QTXMLPATTERNS_LIBRARY}
    apper
)

set_target_properties(apper-pk-session PROPERTIES INSTALL_RPATH ${LIB_INSTALL_DIR}/apper)

install(TARGETS apper-pk-session DESTINATION ${LIBEXEC_INSTALL_DIR})

include(MacroDBusAddActivationService)
dbus_add_activation_service(org.freedesktop.PackageKit.service.in)

=== apperd/CMakeLists.txt ===
set(kded_apperd_SRCS
    DistroUpgrade.cpp
    DBusInterface.cpp
    TransactionJob.cpp
    TransactionWatcher.cpp
    RefreshCacheTask.cpp
    Updater.cpp
    RebootListener.cpp
    ApperdThread.cpp
    apperd.cpp
)

qt4_add_dbus_adaptor(kded_apperd_SRCS
    org.kde.apperd.xml
    DBusInterface.h
    DBusInterface
)

kde4_add_plugin(kded_apperd ${kded_apperd_SRCS})

target_link_libraries(kded_apperd
    ${KDE4_KIO_LIBS}
    ${KDE4_SOLID_LIBS}
    ${KDE4WORKSPACE_KWORKSPACE_LIBS}
    ${PackageKitQt4_LIBRARIES}
    ${DEBCONF_KDE_LIB}
    apper
)

set_target_properties(kded_apperd PROPERTIES INSTALL_RPATH ${LIB_INSTALL_DIR}/apper)

install(TARGETS kded_apperd DESTINATION ${PLUGIN_INSTALL_DIR})
install(FILES apperd.notifyrc DESTINATION ${DATA_INSTALL_DIR}/apperd)
install(FILES apperd.desktop DESTINATION ${SERVICES_INSTALL_DIR}/kded)

=== declarative-plugins/CMakeLists.txt ===
set(apper_qml_plugin_SRCS
   DBusUpdaterInterface.cpp
   daemonhelper.cpp
   qmlplugins.cpp
)

qt4_add_dbus_adaptor(apper_qml_plugin_SRCS
    org.kde.ApperUpdaterIcon.xml
    DBusUpdaterInterface.h
    DBusUpdaterInterface
)

kde4_add_library(apperplugin SHARED ${apper_qml_plugin_SRCS})
target_link_libraries(apperplugin
    ${QT_QTDECLARATIVE_LIBRARY}
    ${KDE4_KDEUI_LIBS}
    ${PackageKitQt4_LIBRARIES}
    apper
)

set_target_properties(apperplugin PROPERTIES INSTALL_RPATH ${LIB_INSTALL_DIR}/apper)

install(TARGETS apperplugin DESTINATION ${IMPORTS_INSTALL_DIR}/org/kde/apper)
install(FILES qmldir DESTINATION ${IMPORTS_INSTALL_DIR}/org/kde/apper)

=== libapper/CMakeLists.txt ===
#Set the correct compiler options
IF(CMAKE_SIZEOF_VOID_P EQUAL 4)
   # 32 bit
   MESSAGE(STATUS "Apper detected that you use a 32 bit processor.")
ELSE(CMAKE_SIZEOF_VOID_P EQUAL 4)
   # 64 bit (well, anything else than 32 bit, but someone use something else than 32 or 64 bit ?)
   set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC")
   MESSAGE(STATUS "Apper detected that you use a 64 bit processor. Added -fPIC to the CXX_FLAGS.")
ENDIF(CMAKE_SIZEOF_VOID_P EQUAL 4)

set(libapper_SRCS
    CategoryMatcher.cpp
    PkIcons.cpp
    PkStrings.cpp
    ApplicationLauncher.cpp
    ApplicationsDelegate.cpp
    ApplicationSortFilterModel.cpp
    CategoryDrawer.cpp
    ChangesDelegate.cpp
    TransactionDelegate.cpp
    PkTransaction.cpp
    PkTransactionWidget.cpp
    PkTransactionProgressModel.cpp
    RepoSig.cpp
    LicenseAgreement.cpp
    PackageModel.cpp
    CustomProgressBar.cpp
    Requirements.cpp
    PackageImportance.cpp
    CategorizedView.cpp
    InfoWidget.cpp
)

if(APPSTREAM)
    pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.36)
    pkg_check_modules(APPSTREAM REQUIRED appstream>=0.6.2)

    set(libapper_SRCS ${libapper_SRCS} AppStream.cpp)
endif()

kde4_add_ui_files(libapper_SRCS
    ApplicationLauncher.ui
    PkTransactionWidget.ui
    RepoSig.ui
    LicenseAgreement.ui
    Requirements.ui
    InfoWidget.ui
)

kde4_add_library(apper SHARED ${libapper_SRCS})

include_directories(${CMAKE_CURRENT_BINARY_DIR}
		    ${GLIB2_INCLUDE_DIR}
		    ${APPSTREAM_INCLUDE_DIRS}
)

target_link_libraries(apper
    ${KDE4_KDEUI_LIBS}
    ${KDE4_KIO_LIBS}
    ${QT_QTSQL_LIBRARY}
    ${PackageKitQt4_LIBRARIES}
    ${APPSTREAM_LIBRARIES}
)

install(TARGETS apper DESTINATION ${LIB_INSTALL_DIR}/apper)

=== po/CMakeLists.txt ===
# The pofiles macro creates in some versions same name targets
# which since cmake 2.8 leads to target clashes.
# Hence force the old policy for all po directories.
# http://public.kitware.com/Bug/view.php?id=12952
cmake_policy(SET CMP0002 OLD)

find_package(Gettext REQUIRED)
if (NOT GETTEXT_MSGMERGE_EXECUTABLE)
MESSAGE(FATAL_ERROR "Please install msgmerge binary")
endif (NOT GETTEXT_MSGMERGE_EXECUTABLE)
if (NOT GETTEXT_MSGFMT_EXECUTABLE)
MESSAGE(FATAL_ERROR "Please install msgmerge binary")
endif (NOT GETTEXT_MSGFMT_EXECUTABLE)
add_subdirectory(ca)
add_subdirectory(pt)
add_subdirectory(ast)
add_subdirectory(en_GB)
add_subdirectory(es)
add_subdirectory(ga)
add_subdirectory(tr)
add_subdirectory(gl)
add_subdirectory(zh_TW)
add_subdirectory(ko)
add_subdirectory(uk)
add_subdirectory(hr)
add_subdirectory(sl)
add_subdirectory(hu)
add_subdirectory(wa)
add_subdirectory(pa)
add_subdirectory(nb)
add_subdirectory(ru)
add_subdirectory(lt)
add_subdirectory(el)
add_subdirectory(fr)
add_subdirectory(de)
add_subdirectory(it)
add_subdirectory(zh_CN)
add_subdirectory(nl)
add_subdirectory(sk)
add_subdirectory(nn)
add_subdirectory(da)
add_subdirectory(eo)
add_subdirectory(mr)
add_subdirectory(pl)
add_subdirectory(ro)
add_subdirectory(ja)
add_subdirectory(sv)
add_subdirectory(et)
add_subdirectory(ca@valencia)
add_subdirectory(cs)
add_subdirectory(pt_BR)
add_subdirectory(fi)
add_subdirectory(nds)
add_subdirectory(ug)
add_subdirectory(bg)
add_subdirectory(bs)

=== po/ru/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES(ru ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} ${_po_files} )

=== debian/changelog ===
apper (0.9.1-2) unstable; urgency=medium

  * Bump standards version: No changes needed
  * Add patch to register QPK metatypes for the Plasmoid (Closes: #766432)

 -- Matthias Klumpp <mak@debian.org>  Thu, 23 Oct 2014 19:58:48 +0200

apper (0.9.1-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream release: 0.9.1
  * Drop all patches: Applied upstream

 -- Matthias Klumpp <mak@debian.org>  Mon, 08 Sep 2014 20:46:32 +0200

apper (0.9.0-1) experimental; urgency=medium

  * New upstream release: 0.9.0

 -- Matthias Klumpp <mak@debian.org>  Sun, 27 Jul 2014 16:08:00 +0200

=== debian/control ===
Source: apper
Section: kde
Priority: optional
Maintainer: Matthias Klumpp <mak@debian.org>
Build-Depends: chrpath,
               cmake (>= 2.8.4),
               debhelper (>= 9.0.0),
               docbook (>= 4.5),
               kde-workspace-dev (>= 4:4.8),
               kdelibs5-dev (>= 4:4.8),
               libappstream-dev (>= 0.7),
               libdbus-1-dev,
               libdebconf-kde-dev,
               liblistaller-glib-dev (>= 0.5.9-2),
               libpackagekitqt4-dev (>= 0.9.2-4),
               pkg-kde-tools (>= 0.14)
Standards-Version: 3.9.6
Homepage: http://kde-apps.org/content/show.php/Apper?content=84745
Vcs-Git: git://anonscm.debian.org/pkg-packagekit/apper.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-packagekit/apper.git

Package: apper
Architecture: any
Depends: apper-data (>= ${source:Version}),
         packagekit (>= 0.8.6),
         polkit-kde-1 | policykit-1-gnome,
         software-properties-kde,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: apper-appsetup (<< 0.7.2)
Breaks: apper-appsetup (<< 0.7.2)
Recommends: appstream-index
Suggests: debconf-kde-helper,
          listaller
Description: KDE package management tool using PackageKit
 PackageKit allows performing simple software management tasks over a DBus
 interface  e.g. refreshing the cache, updating, installing and removing
 software packages or searching for multimedia codecs and file handlers.
 .
 This package provides a KDE package manager based on PackageKit,
 as well as package management support for the KDE desktop.
 It implements the PackageKit session API for KDE, which allows
 applications to easily install additional software (e.g. extensions),
 uninstall files and perform simple software status queries.

Package: apper-data
Architecture: all
Replaces: apper (<< 0.7.2)
Breaks: apper (<< 0.7.2)
Depends: ${misc:Depends}
Description: KDE package management tool using PackageKit (data files)
 PackageKit allows performing simple software management tasks over a DBus
 interface  e.g. refreshing the cache, updating, installing and removing
 software packages or searching for multimedia codecs and file handlers.
 .
 This package provides data files for Apper, the
 KDE package manager based on PackageKit.

Package: apper-dbg
Section: debug
Architecture: any
Priority: extra
Depends: apper (= ${binary:Version}),
         ${misc:Depends}
Recommends: kdelibs5-dbg
Description: Debugging symbols for Apper
 Apper ist a graphical package manager UI based on the PackageKit
 framework as well as a KDE implementation of the PackageKit session
 installer interface.
 .
 This package contains debugging symbols for Apper.
 When Apper crashes, in most cases this package is
 needed to get a backtrace that is useful for developers. If you have
 experienced an Apper crash without this package
 installed, please install it, try to reproduce the problem and fill a bug
 report with a new backtrace attached.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

APPER_CONFIG_FLAGS = -DDEBCONF_SUPPORT=ON \
		-DAPPSTREAM=ON \
		-DLISTALLER=ON \
		-DAUTOREMOVE=ON \
		-DEDIT_ORIGNS_DESKTOP_NAME=software-properties-kde

INSTALLDIR = $(CURDIR)/debian/tmp

%:
	dh $@ --parallel --with kde --dbg-package=apper-dbg

override_dh_auto_configure:
	dh_auto_configure -Skde -- $(APPER_CONFIG_FLAGS)

override_dh_auto_install:
	dh_auto_install --destdir=$(INSTALLDIR)

	# Fix file conflict between GPK and Apper
	mv $(INSTALLDIR)/usr/share/dbus-1/services/org.freedesktop.PackageKit.service $(INSTALLDIR)/usr/share/dbus-1/services/kde-org.freedesktop.PackageKit.service
	# Stupid hack to work around cmake rpath bug
	chrpath --list $(INSTALLDIR)/usr/bin/apper
	chrpath --replace /usr/lib/apper $(INSTALLDIR)/usr/bin/apper

override_dh_install:
	dh_install --list-missing

fetch_translations:
	mkdir -p po
	cd po; svn export svn://anonsvn.kde.org/home/kde/trunk/l10n-kde4/subdirs
	cd po; for asdf in `cat subdirs`; do mkdir -p $${asdf}; done
	cd po; for asdf in `cat subdirs`; do echo $${asdf}; cd $${asdf}; svn export svn://anonsvn.kde.org/home/kde/trunk/l10n-kde4/$${asdf}/messages/extragear-sysadmin/apper.po; cd ..; done
	cd po; rm subdirs; rmdir --ignore-fail-on-non-empty *

=== debian/watch ===
version=3

ftp://ftp.kde.org/pub/kde/stable/apper/([\d\.]+)/src/apper-([\d\.]+)\.tar\.xz \
  debian git-import-orig

## apper 0.9.2+git20161222

=== CMakeLists.txt ===
project(Apper)
cmake_minimum_required(VERSION 3.0)

set(APPER_VERSION 0.9.3)

set (QT_MIN_VERSION "5.2.0")

find_package(ECM REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/)

set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

include(FindPkgConfig)
include(KDEInstallDirs)
include(KDECompilerSettings)
include(KDECMakeSettings)
include(FeatureSummary)
include(ECMInstallIcons)

find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED Core DBus Widgets Quick Sql XmlPatterns)

# Load the frameworks we need
find_package(KF5 REQUIRED COMPONENTS
  Config
  DocTools
  GuiAddons
  I18n
  KCMUtils
  DBusAddons
  KIO
  Notifications
  KDELibs4Support
)
find_package(LibKWorkspace REQUIRED)
find_package(KDED REQUIRED)
find_package(PackageKitQt5 0.9.0 REQUIRED)
find_package(LibKWorkspace REQUIRED)

#
# Options
#
# Only for Debian based systems
option(DEBCONF_SUPPORT "Build Apper with debconf support" OFF)

# Yum does not support this
option(AUTOREMOVE "Build Apper with auto remove enabled" OFF)
set(HAVE_AUTOREMOVE ${AUTOREMOVE})
message(STATUS "Building Apper with auto remove: " ${AUTOREMOVE})

# AppStream application management support
option(APPSTREAM "Build Apper with AppStream support" OFF)
set(HAVE_APPSTREAM ${APPSTREAM})
message(STATUS "Building Apper with AppStream support: " ${APPSTREAM})

# Enable support for Limba packages
option(LIMBA "Build Apper with Limba bundle support" OFF)
set(HAVE_LIMBA ${LIMBA})
message(STATUS "Building Apper with Limba support: " ${LIMBA})

option(MAINTAINER "Enable maintainer mode" OFF)

if(DEBCONF_SUPPORT)
    # Tries to find the package, when it finds it, set HAVE_DEBCONFKDE
    find_package(DebconfKDE REQUIRED)
    message(STATUS "Building with Debconf support")
    set(HAVE_DEBCONF ${DEBCONF_SUPPORT})
endif(DEBCONF_SUPPORT)

# command to edit the packages origins
set(EDIT_ORIGNS_DESKTOP_NAME "" CACHE STRING "Edit origins desktop name")
if (EDIT_ORIGNS_DESKTOP_NAME)
    message(STATUS "Edit origins desktop name: " ${EDIT_ORIGNS_DESKTOP_NAME})
endif(EDIT_ORIGNS_DESKTOP_NAME)

# Generate config.h
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake
               ${CMAKE_CURRENT_BINARY_DIR}/config.h)

#
# Add definitions
#
set(MAINTAINER_CFLAGS "")
if(MAINTAINER)
    set(MAINTAINER_CFLAGS "-Werror -Wall -Wcast-align -Wno-uninitialized -Wempty-body -Wformat-security -Winit-self -Wno-deprecated-declarations")
    if (CMAKE_COMPILER_IS_GNUCC)
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion
                OUTPUT_VARIABLE GCC_VERSION)
        if (GCC_VERSION VERSION_GREATER 4.9 OR GCC_VERSION VERSION_EQUAL 4.9)
            set(MAINTAINER_CFLAGS ${MAINTAINER_CFLAGS} "-fdiagnostics-color=auto")
        endif()
    endif()
endif(MAINTAINER)
add_definitions(${MAINTAINER_CFLAGS})

add_definitions("-std=gnu++11")
add_definitions(
  -DQT_USE_QSTRINGBUILDER
  -DQT_STRICT_ITERATORS
  -DQT_NO_URL_CAST_FROM_STRING
  -DQT_NO_CAST_FROM_BYTEARRAY
  -DQT_NO_SIGNALS_SLOTS_KEYWORDS
  -DQT_USE_FAST_OPERATOR_PLUS
)

#
# Global includes
#
include_directories(${CMAKE_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${PackageKitQt5_INCLUDE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/libapper)

#
# Subcomponents
#
add_subdirectory(libapper)
add_subdirectory(ApperKCM)
add_subdirectory(Apper)
add_subdirectory(PkSession)
add_subdirectory(apperd)
add_subdirectory(declarative-plugins)
add_subdirectory(plasmoid)
add_subdirectory(doc)
if(LIMBA)
    add_subdirectory(AppSetup)
endif()

feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

find_package(KF5I18n CONFIG REQUIRED)
ki18n_install(po)

=== Apper/CMakeLists.txt ===
# CMakeLists for the apper executable and misc data

set(apper_SRCS
    MainUi.cpp
    BackendDetails.cpp
    Apper.cpp
    main.cpp
)

ki18n_wrap_ui(apper_SRCS
    BackendDetails.ui
)

add_executable(apper
    ${apper_SRCS}
)

target_link_libraries(apper
    KF5::KCMUtils
    KF5::IconThemes
    KF5::DBusAddons
    ${PackageKitQt5_LIBRARIES}
    apper_private
)

set_target_properties(apper PROPERTIES INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/apper)

install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/apper DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES org.kde.apper.desktop DESTINATION ${CMAKE_INSTALL_APPDIR})
install(FILES org.kde.apper_installer.desktop DESTINATION ${CMAKE_INSTALL_APPDIR})
install(FILES org.kde.apper_settings.desktop DESTINATION ${CMAKE_INSTALL_APPDIR})
install(FILES org.kde.apper_updates.desktop DESTINATION ${CMAKE_INSTALL_APPDIR})
install(FILES org.kde.apper.appdata.xml DESTINATION ${CMAKE_INSTALL_METAINFODIR})

add_subdirectory(Icons)
add_subdirectory(Animations)

=== ApperKCM/CMakeLists.txt ===
# CMakeLists for the Apper KDE control module (KCM)

add_definitions(-DTRANSLATION_DOMAIN=\"apper\")

set(kcm_apper_SRCS
    Settings/Settings.cpp
    Settings/OriginModel.cpp
    Updater/UpdateDetails.cpp
    Updater/DistroUpgrade.cpp
    Updater/CheckableHeader.cpp
    Updater/Updater.cpp
    FiltersMenu.cpp
    ClickableLabel.cpp
    ScreenShotViewer.cpp
    PackageDetails.cpp
    GraphicsOpacityDropShadowEffect.cpp
    CategoryModel.cpp
    BrowseView.cpp
    TransactionModel.cpp
    TransactionFilterModel.cpp
    TransactionHistory.cpp
    ApperKCM.cpp
)

ki18n_wrap_ui(kcm_apper_SRCS
    Settings/Settings.ui
    Updater/UpdateDetails.ui
    Updater/Updater.ui
    PackageDetails.ui
    BrowseView.ui
    TransactionHistory.ui
    ApperKCM.ui
)

add_library(kcm_apper MODULE ${kcm_apper_SRCS})

target_link_libraries(kcm_apper
    KF5::WidgetsAddons
    KF5::KIOFileWidgets
    KF5::KCMUtils
    KF5::KDELibs4Support
    KF5::IconThemes
    ${PackageKitQt5_LIBRARIES}
    apper_private
)

set_target_properties(kcm_apper PROPERTIES INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/apper)

install(TARGETS kcm_apper DESTINATION ${CMAKE_INSTALL_QTPLUGINDIR})
install(FILES kcm_apper.desktop DESTINATION ${CMAKE_INSTALL_KSERVICES5DIR})

=== PkSession/CMakeLists.txt ===
# CMakeLists for Apper PackageKit Session Interface

set(pksession_SRCS
    AbstractIsRunning.cpp
    FilesModel.cpp
    IntroDialog.cpp
    ReviewChanges.cpp
    SessionTask.cpp
    PkInterface.cpp
    PkInstallPackageNames.cpp
    PkSearchFile.cpp
    PkIsInstalled.cpp
    PkInstallMimeTypes.cpp
    PkInstallGStreamerResources.cpp
    PkInstallFontconfigResources.cpp
    PkInstallPlasmaResources.cpp
    PkInstallPackageFiles.cpp
    PkInstallProvideFiles.cpp
    PkInstallCatalogs.cpp
    PkRemovePackageByFiles.cpp
    PkInstallPrinterDrivers.cpp
    PkSession.cpp
    main.cpp
)

qt5_add_dbus_adaptor(pksession_SRCS
    org.freedesktop.PackageKit.xml
    PkInterface.h
    PkInterface
)

ki18n_wrap_ui(pksession_SRCS
    IntroDialog.ui
    ReviewChanges.ui
    SessionTask.ui
)

add_executable(apper-pk-session
    ${pksession_SRCS}
)

target_link_libraries(apper-pk-session
    KF5::WidgetsAddons
    KF5::KIOFileWidgets
    KF5::KDELibs4Support
    KF5::IconThemes
    ${PackageKitQt5_LIBRARIES}
    apper_private
)

qt5_use_modules(apper-pk-session Core XmlPatterns)

set_target_properties(apper-pk-session PROPERTIES INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/apper)

install(TARGETS apper-pk-session DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

include(MacroDBusAddActivationService)
dbus_add_activation_service(org.freedesktop.PackageKit.service.in)

=== apperd/CMakeLists.txt ===
# CMakeLists for the kded component

set(kded_apperd_SRCS
    DistroUpgrade.cpp
    DBusInterface.cpp
    TransactionJob.cpp
    TransactionWatcher.cpp
    RefreshCacheTask.cpp
    Updater.cpp
    RebootListener.cpp
    ApperdThread.cpp
    apperd.cpp
)

qt5_add_dbus_adaptor(kded_apperd_SRCS
    org.kde.apperd.xml
    DBusInterface.h
    DBusInterface
)

add_library(kded_apperd MODULE ${kded_apperd_SRCS})

target_link_libraries(kded_apperd
    KF5::WidgetsAddons
    KF5::KIOFileWidgets
    KF5::KDELibs4Support
    KF5::IconThemes
    KF5::Notifications
    KF5::DBusAddons
    ${PackageKitQt5_LIBRARIES}
    PW::KWorkspace
    apper_private
)

if(DEBCONF_SUPPORT)
target_link_libraries(kded_apperd DebconfKDE::Main)
endif(DEBUCONF_SUPPORT)

set_target_properties(kded_apperd PROPERTIES INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR}/apper)

install(TARGETS kded_apperd DESTINATION ${CMAKE_INSTALL_QTPLUGINDIR})
install(FILES apperd.notifyrc DESTINATION ${CMAKE_INSTALL_DATADIR}/apperd)
install(FILES apperd.desktop DESTINATION ${CMAKE_INSTALL_KSERVICES5DIR}/kded)

=== libapper/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,8 @@
-#Set the correct compiler options
+# CMakeLists for Apper private shared library
+
+add_definitions(-DTRANSLATION_DOMAIN=\"apper\")
+
+# Set the correct compiler options
 IF(CMAKE_SIZEOF_VOID_P EQUAL 4)
    # 32 bit
    MESSAGE(STATUS "Apper detected that you use a 32 bit processor.")
@@ -33,12 +37,12 @@
 
 if(APPSTREAM)
     pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.36)
-    pkg_check_modules(APPSTREAM REQUIRED appstream>=0.6.2)
+    pkg_check_modules(APPSTREAM REQUIRED appstream>=0.10.0)
 
     set(libapper_SRCS ${libapper_SRCS} AppStream.cpp)
 endif()
 
-kde4_add_ui_files(libapper_SRCS
+ki18n_wrap_ui(libapper_SRCS
     ApplicationLauncher.ui
     PkTransactionWidget.ui
     RepoSig.ui
@@ -47,19 +51,23 @@
     InfoWidget.ui
 )
 
-kde4_add_library(apper SHARED ${libapper_SRCS})
+add_library(apper_private SHARED ${libapper_SRCS})
 
 include_directories(${CMAKE_CURRENT_BINARY_DIR}
-		    ${GLIB2_INCLUDE_DIR}
-		    ${APPSTREAM_INCLUDE_DIRS}
+    ${GLIB2_INCLUDE_DIR}
+    ${APPSTREAM_INCLUDE_DIRS}
 )
 
-target_link_libraries(apper
-    ${KDE4_KDEUI_LIBS}
-    ${KDE4_KIO_LIBS}
+target_link_libraries(apper_private
+    KF5::WidgetsAddons
+    KF5::KIOFileWidgets
+    KF5::KDELibs4Support
+    KF5::IconThemes
     ${QT_QTSQL_LIBRARY}
-    ${PackageKitQt4_LIBRARIES}
+    ${PackageKitQt5_LIBRARIES}
     ${APPSTREAM_LIBRARIES}
 )
 
-install(TARGETS apper DESTINATION ${LIB_INSTALL_DIR}/apper)
+qt5_use_modules(apper_private Quick Core Sql)
+
+install(TARGETS apper_private DESTINATION ${CMAKE_INSTALL_LIBDIR}/apper)

=== debian/changelog ===
apper (0.9.2+git20161222-3) unstable; urgency=medium

  * Enable AppStream icon download explicitly
  * Don't install the updater Plasmoid (Closes: #851117)
    - The updater Plasmoid is currently broken and will need some
      work to be revived. We can not ship with it for Debian Stretch.
      Having two default-enabled updater icons also is very confusing
      to users, so if the updater gets ported to recent QtQuick and
      received upstream fixes, we can bring it back as separate package.

 -- Matthias Klumpp <mak@debian.org>  Thu, 19 Jan 2017 20:45:22 +0100

apper (0.9.2+git20161222-2) unstable; urgency=medium

  * Hack around rpath oddness (Closes: #849956)
  * apper-icon.patch: Set the right icon for Apper

 -- Matthias Klumpp <mak@debian.org>  Sun, 08 Jan 2017 18:24:12 +0100

apper (0.9.2+git20161222-1) unstable; urgency=medium

  * New upstream Git snapshot: 0.9.2+git20161222
    - The package is brought back to unstable due to a lot of
      users requesting it, but since it is essentially dead upstream
      and I do not know how well it works for most users,
      I will drop it from the Debian Stretch release if it is found to
      be unfit and issues can not be fixed in time.
      Any help (patches! - and testing) is appreciated.
  * Use secure Vcs-* URLs
  * Bump dh compat level to 10
  * Drop manual debug package in favor of automatic dbgsym packages

 -- Matthias Klumpp <mak@debian.org>  Thu, 22 Dec 2016 20:54:58 +0100

apper (0.9.2+git20150930-1) experimental; urgency=medium

  * New upstream Git snapshot: 0.9.2+git20150930 (e0bf3649)
  * Drop patches: Applied upstream

 -- Matthias Klumpp <mak@debian.org>  Wed, 30 Sep 2015 19:14:45 +0200

apper (0.9.2-3) unstable; urgency=medium

  * Build-depend on libdebconf-kde0-dev
  * Depend on appstream instead of appstream-index

 -- Matthias Klumpp <mak@debian.org>  Wed, 26 Aug 2015 18:15:32 +0200

apper (0.9.2-2) unstable; urgency=medium

  * Upload to unstable

 -- Matthias Klumpp <mak@debian.org>  Sun, 21 Jun 2015 14:58:20 +0200

apper (0.9.2-1) experimental; urgency=medium

  * New upstream release: 0.9.2
  * Drop all patches: Applied upstream
  * Fix compiler warning
  * Only depend on Limba on linux-any

 -- Matthias Klumpp <mak@debian.org>  Sun, 26 Apr 2015 16:08:38 +0200

=== debian/control ===
Source: apper
Section: kde
Priority: optional
Maintainer: Matthias Klumpp <mak@debian.org>
Build-Depends: chrpath,
               cmake (>= 3.0),
               debhelper (>= 10),
               docbook (>= 4.5),
               extra-cmake-modules (>= 5.14),
               kded5-dev,
               kdelibs5-dev,
               kio-dev,
               libappstream-dev (>= 0.8),
               libdebconf-kde-dev (>= 1.0.2),
               libkf5config-dev,
               libkf5dbusaddons-dev,
               libkf5guiaddons-dev,
               libkf5i18n-dev,
               libkf5kcmutils-dev,
               libkf5kdelibs4support-dev,
               libkf5notifications-dev,
               liblimba-dev (>= 0.4) [linux-any],
               libpackagekitqt5-dev (>= 0.9.2-4),
               libqt5xmlpatterns5-dev,
               pkg-kde-tools (>= 0.15),
               plasma-workspace-dev
Standards-Version: 3.9.8
Homepage: https://www.linux-apps.com/content/show.php/Apper?content=84745
Vcs-Git: https://anonscm.debian.org/git/pkg-packagekit/apper.git
Vcs-Browser: https://anonscm.debian.org/git/pkg-packagekit/apper.git

Package: apper
Architecture: any
Depends: apper-data (>= ${source:Version}),
         packagekit (>= 0.8.6),
         polkit-kde-1 | policykit-1-gnome,
         software-properties-kde,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: apper-appsetup (<< 0.7.2)
Breaks: apper-appsetup (<< 0.7.2)
Recommends: appstream,
            debconf-kde-helper
Suggests: limba [linux-any]
Description: KDE package management tool using PackageKit
 PackageKit allows performing simple software management tasks over a DBus
 interface  e.g. refreshing the cache, updating, installing and removing
 software packages or searching for multimedia codecs and file handlers.
 .
 This package provides a KDE package manager based on PackageKit,
 as well as package management support for the KDE desktop.
 It implements the PackageKit session API for KDE, which allows
 applications to easily install additional software (e.g. extensions),
 uninstall files and perform simple software status queries.

Package: apper-data
Architecture: all
Replaces: apper (<< 0.7.2)
Breaks: apper (<< 0.7.2)
Depends: ${misc:Depends}
Description: KDE package management tool using PackageKit (data files)
 PackageKit allows performing simple software management tasks over a DBus
 interface  e.g. refreshing the cache, updating, installing and removing
 software packages or searching for multimedia codecs and file handlers.
 .
 This package provides data files for Apper, the
 KDE package manager based on PackageKit.

=== debian/rules ===
--- 
+++ 
@@ -6,14 +6,19 @@
 
 APPER_CONFIG_FLAGS = -DDEBCONF_SUPPORT=ON \
 		-DAPPSTREAM=ON \
-		-DLISTALLER=ON \
 		-DAUTOREMOVE=ON \
 		-DEDIT_ORIGNS_DESKTOP_NAME=software-properties-kde
+
+ifeq ($(DEB_HOST_ARCH_OS), linux)
+	APPER_CONFIG_FLAGS += -DLIMBA=ON
+endif
+
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 INSTALLDIR = $(CURDIR)/debian/tmp
 
 %:
-	dh $@ --parallel --with kde --dbg-package=apper-dbg
+	dh $@ --parallel --with kde
 
 override_dh_auto_configure:
 	dh_auto_configure -Skde -- $(APPER_CONFIG_FLAGS)
@@ -21,13 +26,16 @@
 override_dh_auto_install:
 	dh_auto_install --destdir=$(INSTALLDIR)
 
-	# Fix file conflict between GPK and Apper
+	# Fix file conflict between GS and Apper
 	mv $(INSTALLDIR)/usr/share/dbus-1/services/org.freedesktop.PackageKit.service $(INSTALLDIR)/usr/share/dbus-1/services/kde-org.freedesktop.PackageKit.service
-	# Stupid hack to work around cmake rpath bug
+
+	# hack around rpath oddness
 	chrpath --list $(INSTALLDIR)/usr/bin/apper
-	chrpath --replace /usr/lib/apper $(INSTALLDIR)/usr/bin/apper
+	chrpath --replace /usr/lib/$(DEB_HOST_MULTIARCH)/apper $(INSTALLDIR)/usr/bin/apper
 
 override_dh_install:
+	# FIXME: Temporarily disable the update notifier applet
+	rm -f $(INSTALLDIR)/usr/share/kservices5/plasma-applet-org.packagekit.updater
 	dh_install --list-missing
 
 fetch_translations:

=== debian/watch ===
version=3

http://download.kde.org/stable/apper/([\d\.]+)/src/apper-([\d\.]+)\.tar\.xz \
  debian git-import-orig
